"""
replace_connection_utils.py

Contains utility functions for batch updating featuresources of one or more Layer Definitions in a given folder
"""
def UpdateLayersFeatureSchema(conn, folder, oldSchema, newSchema):
    """
    Modifies the featuresource of layerdefinition matching the old featureschema name
    """
    resList = conn.ResourceService.GetRepositoryResources(folder, "LayerDefinition")
    # adds : to ensure we work with schema:
    oldSchema = oldSchema + ":"
    newSchema = newSchema + ":"
    for child in resList.Children:
        ldf = conn.ResourceService.GetResource(child.ResourceId)
        # get actual featurename
        currentF = ldf.SubLayer.FeatureName
        print "Replacing: %s,%s" % (child.ResourceId,currentF)
        if (currentF.startswith(oldSchema)):
            ldf.SubLayer.FeatureName = currentF.replace(oldSchema, newSchema)
            # Save the changes back
            conn.ResourceService.SaveResource(ldf)
            print "schema set to %s" % (currentF)
            print "Saved: %s" % (child.ResourceId)
        else :
            print "Keeping schema : %s" % (currentF)

def UpdateLayersFeatureSource(conn, folder, oldF, newF):
    """
    Modifies the featuresource of layerdefinition matching the old featuresource name
    """
    resList = conn.ResourceService.GetRepositoryResources(folder, "LayerDefinition")
    
    for child in resList.Children:
        ldf = conn.ResourceService.GetResource(child.ResourceId)
        # get actual source
        currentF = ldf.SubLayer.ResourceId
        print "Replacing: %s,%s" % (child.ResourceId,currentF)
        if (currentF == oldF):
            ldf.SubLayer.ResourceId = newF
            # Save the changes back
            conn.ResourceService.SaveResource(ldf)
            print "FeatureSource set to %s" % (currentF)
            print "Saved: %s" % (child.ResourceId)
        else :
            print "Keeping source : %s" % (currentF)